	list p=16f877a
	#include <p16f877a.inc>
	radix dec
; Compiled with: PIC Simulator IDE v6.73
; Microcontroller model: PIC16F877A
; Clock frequency: 16.0 MHz
; Begin
	R0L EQU 0x20
	R0H EQU 0x21
	R1L EQU 0x22
	R1H EQU 0x23
	R2L EQU 0x24
	R2H EQU 0x25
	R3L EQU 0x26
	R3H EQU 0x27
	R4L EQU 0x28
	R4H EQU 0x29
	R5L EQU 0x2A
	R5H EQU 0x2B
	W_TEMP EQU 0x7F
	STATUS_TEMP EQU 0x7E
	R0L_TEMP EQU 0x2C
	R0H_TEMP EQU 0x2D
	R1L_TEMP EQU 0x2E
	R1H_TEMP EQU 0x2F
	R2L_TEMP EQU 0x30
	R2H_TEMP EQU 0x31
	R3L_TEMP EQU 0x32
	R3H_TEMP EQU 0x33
	R4L_TEMP EQU 0x34
	R4H_TEMP EQU 0x35
	R5L_TEMP EQU 0x36
	R5H_TEMP EQU 0x37
	FSR_TEMP EQU 0x38
	ORG 0x0000
	BCF PCLATH,3
	BCF PCLATH,4
	GOTO L0006
	ORG 0x0004
	MOVWF W_TEMP
	SWAPF STATUS,W
	CLRF STATUS
	MOVWF STATUS_TEMP
	CALL L0007
	SWAPF STATUS_TEMP,W
	MOVWF STATUS
	SWAPF W_TEMP,F
	SWAPF W_TEMP,W
	RETFIE
L0006:
; 1:  'Updated parameters  15Feb2010
; 2:  '16F877A PIC with a 16mHz Xtal
; 3: 
; 4: 
; 5:  '0.5v = 0l = 0%
; 6:  '3.71v = 20l = 100%
; 7: 
; 8:  'NOTE: The resistive divider on the 5V input is set to give 4.88v, which is 1000 adc counts
; 9:  'that means we must also correct the 0.5v and 3.71v by the same factor
; 10:  'So 4.888/5.000 = 0.976
; 11:  '5.0V external *  0.976 = 4.88  at the adc input == 1000 adc counts
; 12:  '0.5V external  * 0.976 = 0.48V at the adc input ==  100 adc counts  = 0%  0L
; 13:  '3.71v external * 0.976 = 3.62v at the adc input ==  741 counts      = 100% 20L
; 14:  '2.1v is the centre point so, 2.05v at the adc input = 420 counts    = 50%  10L
; 15: 
; 16:  ''Define SIMULATION_WAITMS_VALUE = 1  'make this =0 for programming a PIC
; 17: 
; 18: Define ADC_CLOCK = 3 'default value is 3
; 19: Define ADC_SAMPLEUS = 10 'default value is 20
; 20: Define LCD_BITS = 8 'allowed values are 4 and 8 - the number of data interface lines
; 21: Define LCD_DREG = PORTD
; 22: Define LCD_DBIT = 0 '0 or 4 for 4-bit interface, ignored for 8-bit interface
; 23: Define LCD_RSREG = PORTC
; 24: Define LCD_RSBIT = 0
; 25: Define LCD_EREG = PORTC
; 26: Define LCD_EBIT = 1
; 27: Define LCD_RWREG = 0
; 28: Define LCD_RWBIT = 0 'set to 0 if not used, 0 is default
; 29: Define LCD_COMMANDUS = 100 'delay after LCDCMDOUT, default value is 5000
; 30:  'Define LCD_DATAUS = 10 'delay after LCDOUT, default value is 50
; 31:  'Define LCD_INITMS = 1 'delay used by LCDINIT, default value is 100
; 32:  'the last three Define directives set the values suitable for simulation; they should be omitted for a real device
; 33:  '------------------------------------
; 34:  'setup temp variables
; 35: Dim ascbfr4 As Byte
;       The address of 'ascbfr4' is 0x39
	ascbfr4 EQU 0x39
; 36: Dim ascbfr3 As Byte
;       The address of 'ascbfr3' is 0x3A
	ascbfr3 EQU 0x3A
; 37: Dim ascbfr2 As Byte
;       The address of 'ascbfr2' is 0x3B
	ascbfr2 EQU 0x3B
; 38: Dim ascbfr1 As Byte
;       The address of 'ascbfr1' is 0x3C
	ascbfr1 EQU 0x3C
; 39: Dim ascbfr0 As Byte
;       The address of 'ascbfr0' is 0x3D
	ascbfr0 EQU 0x3D
; 40: 
; 41: Dim temp3 As Word
;       The address of 'temp3' is 0x3E
	temp3 EQU 0x3E
; 42: Dim binval As Word
;       The address of 'binval' is 0x40
	binval EQU 0x40
; 43: 
; 44: Dim volt0 As Word
;       The address of 'volt0' is 0x42
	volt0 EQU 0x42
; 45: Dim vol1 As Word
;       The address of 'vol1' is 0x44
	vol1 EQU 0x44
; 46: 
; 47: Dim intrcnt As Byte
;       The address of 'intrcnt' is 0x46
	intrcnt EQU 0x46
; 48: Dim adcavg1 As Word
;       The address of 'adcavg1' is 0x47
	adcavg1 EQU 0x47
; 49: 
; 50:  '''''''''''''''''''
; 51: T1CON.T1OSCEN = 1
	BSF 0x10,3
; 52: T1CON.TMR1CS = 0
	BCF 0x10,1
; 53: T1CON.TMR1ON = 1
	BSF 0x10,0
; 54: T1CON.T1CKPS0 = 1 'tmr1 prescaler /256 gives a 2 microsec clock period
	BSF 0x10,4
; 55: T1CON.T1CKPS1 = 1
	BSF 0x10,5
; 56: 
; 57: TMR1H = 0x3c ''0x3c ~ 0.1 sec/intr
	MOVLW 0x3C
	MOVWF 0x0F
; 58: TMR1L = 0xb0 ''0xb0
	MOVLW 0xB0
	MOVWF 0x0E
; 59: 
; 60: INTCON.GIE = 1
	BSF 0x0B,7
; 61: INTCON.PEIE = 1
	BSF 0x0B,6
; 62: 
; 63: PIR1.TMR1IF = 0
	BCF 0x0C,0
; 64:  '''''''''''''''''''''''''''''''
; 65: 
; 66: ADCON0 = %01000001 'fosc/8
	MOVLW 0x41
	MOVWF 0x1F
; 67: ADCON1 = %10000100 'Dis clk div,,,an0 > an3 analaog rest dig
	BSF STATUS,RP0
	MOVLW 0x84
	MOVWF 0x1F
; 68: 
; 69: TRISA = %00001111
	MOVLW 0x0F
	MOVWF 0x05
; 70: TRISB = %00000001 'reserve portb.0 for ext interrupts, if required
	MOVLW 0x01
	MOVWF 0x06
; 71: TRISC = %11111111
	MOVLW 0xFF
	MOVWF 0x07
; 72:  '-----------------------------------------------------
; 73: 
	BCF STATUS,RP0
; 74: Lcdinit
	BCF 0x07,1
	BCF 0x07,0
	BSF STATUS,RP0
	BCF 0x07,1
	BCF 0x07,0
	CLRF 0x08
	BCF STATUS,RP0
	MOVLW 0x64
	MOVWF R0L
	MOVLW 0x00
	MOVWF R0H
	CALL W001
	MOVLW 0x33
	CALL LC02
	MOVLW 0x33
	CALL LC02
	MOVLW 0x33
	CALL LC02
	MOVLW 0x38
	CALL LC02
	MOVLW 0x0C
	CALL LC02
	MOVLW 0x01
	CALL LC02
; 75: 
; 76: Lcddefchar 0, 31, 31, 31, 31, 31, 31, 31, 31
	MOVLW 0x40
	CALL LC02
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x02
	CALL LC02
; 77: Lcddefchar 1, %00011111, %00011111, %00011111, %00011111, %00011111, %00011111, %00011111, %00011111
	MOVLW 0x48
	CALL LC02
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x1F
	CALL LC01
	MOVLW 0x02
	CALL LC02
; 78: Lcdout 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
	MOVLW 0x00
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
	MOVLW 0x01
	CALL LC01
; 79: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 80: Lcdout 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
	MOVLW 0x00
	CALL LC01
; 81: 
; 82: WaitMs 1000
	MOVLW 0xE8
	MOVWF R0L
	MOVLW 0x03
	MOVWF R0H
	CALL W001
; 83: 
; 84: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 85: Lcdout "**Initialising**"
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x49
	CALL LC01
	MOVLW 0x6E
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x61
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x73
	CALL LC01
	MOVLW 0x69
	CALL LC01
	MOVLW 0x6E
	CALL LC01
	MOVLW 0x67
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
; 86: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 87: Lcdout "*****FLIPS******"
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x46
	CALL LC01
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x49
	CALL LC01
	MOVLW 0x50
	CALL LC01
	MOVLW 0x53
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
	MOVLW 0x2A
	CALL LC01
; 88: WaitMs 750
	MOVLW 0xEE
	MOVWF R0L
	MOVLW 0x02
	MOVWF R0H
	CALL W001
; 89: Lcdcmdout LcdHome
	MOVLW 0x02
	CALL LC02
; 90: Lcdout " PLEASE "
	MOVLW 0x20
	CALL LC01
	MOVLW 0x50
	CALL LC01
	MOVLW 0x4C
	CALL LC01
	MOVLW 0x45
	CALL LC01
	MOVLW 0x41
	CALL LC01
	MOVLW 0x53
	CALL LC01
	MOVLW 0x45
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 91: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 92: Lcdout " WAIT "
	MOVLW 0x20
	CALL LC01
	MOVLW 0x57
	CALL LC01
	MOVLW 0x41
	CALL LC01
	MOVLW 0x49
	CALL LC01
	MOVLW 0x54
	CALL LC01
	MOVLW 0x20
	CALL LC01
; 93: WaitMs 750
	MOVLW 0xEE
	MOVWF R0L
	MOVLW 0x02
	MOVWF R0H
	CALL W001
; 94: Lcdcmdout LcdClear
	MOVLW 0x01
	CALL LC02
; 95: 
; 96: main0: 
L0001:
; 97: 
; 98: PIR1.TMR1IF = 0
	BCF 0x0C,0
; 99: PIE1.TMR1IE = 1 'enable TMR1 interrupt
	BSF STATUS,RP0
	BSF 0x0C,0
; 100: adcavg1 = 0
	BCF STATUS,RP0
	CLRF 0x47
	CLRF 0x48
; 101: vol1 = 0
	CLRF 0x44
	CLRF 0x45
; 102: Enable 'enable interrupts
	BSF INTCON,GIE
; 103: 
; 104: main:  'loop
L0002:
; 105: 
; 106: If intrcnt > 4 Then
	MOVF 0x46,W
	SUBLW 0x04
	BTFSC STATUS,C
	GOTO L0008
; 107: intrcnt = 0
	CLRF 0x46
; 108: 
; 109: vol1 = adcavg1 / 5 'get the average
	MOVF 0x47,W
	MOVWF R0L
	MOVF 0x48,W
	MOVWF R0H
	MOVLW 0x05
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x44
	MOVF R0H,W
	MOVWF 0x45
; 110: adcavg1 = 0
	CLRF 0x47
	CLRF 0x48
; 111: 
; 112:  'test for lower and upper limits
; 113: If vol1 < 100 Then 'less than 0.488v [0.5v]
	MOVF 0x44,W
	MOVWF R0L
	MOVF 0x45,W
	MOVWF R0H
	CLRF R1H
	MOVLW 0x64
	CALL C004
	BTFSS STATUS,Z
	GOTO L0009
; 114: vol1 = 0
	CLRF 0x44
	CLRF 0x45
; 115: Goto show1
	GOTO L0003
; 116: Endif
L0009:	MOVLW 0x1F
	ANDWF STATUS,F
; 117: 
; 118: If vol1 > 741 Then 'greater/equal 3.62v [3.71v]
	MOVF 0x44,W
	MOVWF R0L
	MOVF 0x45,W
	MOVWF R0H
	MOVLW 0x02
	MOVWF R1H
	MOVLW 0xE5
	CALL C003
	BTFSS STATUS,Z
	GOTO L0010
; 119: vol1 = 1000
	MOVLW 0xE8
	MOVWF 0x44
	MOVLW 0x03
	MOVWF 0x45
; 120: Goto show1
	GOTO L0003
; 121: Endif
L0010:	MOVLW 0x1F
	ANDWF STATUS,F
; 122: 
; 123: vol1 = vol1 * 81 'adjust the span of the range
	MOVF 0x44,W
	MOVWF R3L
	MOVF 0x45,W
	MOVWF R3H
	MOVLW 0x51
	MOVWF R1L
	CLRF R1H
	CALL M001
	MOVWF 0x44
	MOVF R2H,W
	MOVWF 0x45
; 124: vol1 = vol1 - 8100 'subtract the offset adjusted
	MOVLW 0xA4
	SUBWF 0x44,W
	MOVWF 0x44
	MOVLW 0x1F
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF 0x45,W
	MOVWF 0x45
; 125: vol1 = vol1 / 52
	MOVF 0x44,W
	MOVWF R0L
	MOVF 0x45,W
	MOVWF R0H
	MOVLW 0x34
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x44
	MOVF R0H,W
	MOVWF 0x45
; 126: 
; 127: show1: 
L0003:
; 128: binval = vol1
	MOVF 0x44,W
	MOVWF 0x40
	MOVF 0x45,W
	MOVWF 0x41
; 129: Gosub bin2asc
	CALL L0005
; 130: Lcdcmdout LcdLine1Home
	MOVLW 0x80
	CALL LC02
; 131: Lcdout "Percent: ", ascbfr3, ascbfr2, ascbfr1, ".", ascbfr0, "%"
	MOVLW 0x50
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x72
	CALL LC01
	MOVLW 0x63
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x6E
	CALL LC01
	MOVLW 0x74
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVLW 0x20
	CALL LC01
	MOVF 0x3A,W
	CALL LC01
	MOVF 0x3B,W
	CALL LC01
	MOVF 0x3C,W
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVF 0x3D,W
	CALL LC01
	MOVLW 0x25
	CALL LC01
; 132: 
; 133: binval = vol1 / 5
	MOVF 0x44,W
	MOVWF R0L
	MOVF 0x45,W
	MOVWF R0H
	MOVLW 0x05
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x40
	MOVF R0H,W
	MOVWF 0x41
; 134: Gosub bin2asc
	CALL L0005
; 135: Lcdcmdout LcdLine2Home
	MOVLW 0xC0
	CALL LC02
; 136: Lcdout "Volume:", ascbfr2, ascbfr1, ".", ascbfr0, "L"
	MOVLW 0x56
	CALL LC01
	MOVLW 0x6F
	CALL LC01
	MOVLW 0x6C
	CALL LC01
	MOVLW 0x75
	CALL LC01
	MOVLW 0x6D
	CALL LC01
	MOVLW 0x65
	CALL LC01
	MOVLW 0x3A
	CALL LC01
	MOVF 0x3B,W
	CALL LC01
	MOVF 0x3C,W
	CALL LC01
	MOVLW 0x2E
	CALL LC01
	MOVF 0x3D,W
	CALL LC01
	MOVLW 0x4C
	CALL LC01
; 137: 
; 138: Endif
L0008:	MOVLW 0x1F
	ANDWF STATUS,F
; 139: 
; 140: Goto main
	GOTO L0002
; 141: 
; 142: End
L0011:	GOTO L0011
; 143: On Interrupt
L0007:
; 144: Save System
	MOVF R0L,W
	MOVWF R0L_TEMP
	MOVF R0H,W
	MOVWF R0H_TEMP
	MOVF R1L,W
	MOVWF R1L_TEMP
	MOVF R1H,W
	MOVWF R1H_TEMP
	MOVF R2L,W
	MOVWF R2L_TEMP
	MOVF R2H,W
	MOVWF R2H_TEMP
	MOVF R3L,W
	MOVWF R3L_TEMP
	MOVF R3H,W
	MOVWF R3H_TEMP
	MOVF R4L,W
	MOVWF R4L_TEMP
	MOVF R4H,W
	MOVWF R4H_TEMP
	MOVF R5L,W
	MOVWF R5L_TEMP
	MOVF R5H,W
	MOVWF R5H_TEMP
	MOVF FSR,W
	MOVWF FSR_TEMP
; 145: 
; 146: PIR1.TMR1IF = 0
	BCF 0x0C,0
; 147: 
; 148: TMR1H = 0x3c ''0x3c
	MOVLW 0x3C
	MOVWF 0x0F
; 149: TMR1L = 0xb0 ''0xb0
	MOVLW 0xB0
	MOVWF 0x0E
; 150: 
; 151: intrcnt = intrcnt + 1
	MOVF 0x46,W
	ADDLW 0x01
	MOVWF 0x46
; 152: 
; 153:  'scale the 5V input to 4.88v using a resistive divider
; 154: readadc:  'read adc word
L0004:
; 155: Adcin 0, volt0
	BSF STATUS,RP0
	BSF ADCON1,ADFM
	BCF ADCON1,ADCS2
	MOVLW 0x00
	BCF STATUS,RP0
	MOVWF R0L
	CALL A001
	BSF STATUS,RP0
	MOVF ADRESL,W
	BCF STATUS,RP0
	MOVWF 0x42
	MOVF ADRESH,W
	MOVWF 0x43
; 156: 
; 157: adcavg1 = adcavg1 + volt0
	MOVF 0x47,W
	ADDWF 0x42,W
	MOVWF 0x47
	MOVF 0x48,W
	BTFSC STATUS,C
	ADDLW 0x01
	ADDWF 0x43,W
	MOVWF 0x48
; 158: 
; 159: Resume
	MOVF R0L_TEMP,W
	MOVWF R0L
	MOVF R0H_TEMP,W
	MOVWF R0H
	MOVF R1L_TEMP,W
	MOVWF R1L
	MOVF R1H_TEMP,W
	MOVWF R1H
	MOVF R2L_TEMP,W
	MOVWF R2L
	MOVF R2H_TEMP,W
	MOVWF R2H
	MOVF R3L_TEMP,W
	MOVWF R3L
	MOVF R3H_TEMP,W
	MOVWF R3H
	MOVF R4L_TEMP,W
	MOVWF R4L
	MOVF R4H_TEMP,W
	MOVWF R4H
	MOVF R5L_TEMP,W
	MOVWF R5L
	MOVF R5H_TEMP,W
	MOVWF R5H
	MOVF FSR_TEMP,W
	MOVWF FSR
	RETURN
; 160: 
; 161: 
; 162:  'you can convert any binary value from 0000h to fffFh to 0000 to 65535 decimal
; 163:  'just name the binary word as binval and call this subr and the ASCII
; 164:  'result will be in ascbfr4,3,2,1,0, ready for your LCD or UART
; 165:  'just pop the DP in the output to the LCD [as shown above]
; 166: 
; 167: bin2asc: 
L0005:
; 168:  'ascbfr4 = binval / 10000 'add these 4 lines for 16 bit conv
; 169:  'temp3 = binval Mod 10000
; 170:  'ascbfr3 = temp3 / 1000
; 171:  'temp3 = binval Mod 1000
; 172: 
; 173: ascbfr3 = binval / 1000 'delete for 16 bit conv
;       The address of 'oshonsoft_temp_1' is 0x49
	oshonsoft_temp_1 EQU 0x49
	MOVF 0x40,W
	MOVWF R0L
	MOVF 0x41,W
	MOVWF R0H
	MOVLW 0xE8
	MOVWF R1L
	MOVLW 0x03
	MOVWF R1H
	CALL D001
	MOVWF 0x49
	MOVF R0H,W
	MOVWF 0x4A
	MOVF 0x49,W
	MOVWF 0x3A
; 174: temp3 = binval Mod 1000 'delete for 16 bit
	MOVF 0x40,W
	MOVWF R0L
	MOVF 0x41,W
	MOVWF R0H
	MOVLW 0xE8
	MOVWF R1L
	MOVLW 0x03
	MOVWF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x3E
	MOVF R2H,W
	MOVWF 0x3F
; 175: 
; 176: ascbfr2 = temp3 / 100
	MOVF 0x3E,W
	MOVWF R0L
	MOVF 0x3F,W
	MOVWF R0H
	MOVLW 0x64
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x49
	MOVF R0H,W
	MOVWF 0x4A
	MOVF 0x49,W
	MOVWF 0x3B
; 177: temp3 = temp3 Mod 100
	MOVF 0x3E,W
	MOVWF R0L
	MOVF 0x3F,W
	MOVWF R0H
	MOVLW 0x64
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x3E
	MOVF R2H,W
	MOVWF 0x3F
; 178: 
; 179: ascbfr1 = temp3 / 10
	MOVF 0x3E,W
	MOVWF R0L
	MOVF 0x3F,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVWF 0x49
	MOVF R0H,W
	MOVWF 0x4A
	MOVF 0x49,W
	MOVWF 0x3C
; 180: ascbfr0 = temp3 Mod 10
	MOVF 0x3E,W
	MOVWF R0L
	MOVF 0x3F,W
	MOVWF R0H
	MOVLW 0x0A
	MOVWF R1L
	CLRF R1H
	CALL D001
	MOVF R2L,W
	MOVWF 0x49
	MOVF R2H,W
	MOVWF 0x4A
	MOVF 0x49,W
	MOVWF 0x3D
; 181:  'results are BCD so
; 182:  'convert to ASCII for LCD or UART
; 183: ascbfr4 = ascbfr4 Or 0x30
	MOVF 0x39,W
	MOVWF R0L
	MOVLW 0x30
	IORWF R0L,W
	MOVWF 0x39
; 184: ascbfr3 = ascbfr3 Or 0x30
	MOVF 0x3A,W
	MOVWF R0L
	MOVLW 0x30
	IORWF R0L,W
	MOVWF 0x3A
; 185: ascbfr2 = ascbfr2 Or 0x30
	MOVF 0x3B,W
	MOVWF R0L
	MOVLW 0x30
	IORWF R0L,W
	MOVWF 0x3B
; 186: ascbfr1 = ascbfr1 Or 0x30
	MOVF 0x3C,W
	MOVWF R0L
	MOVLW 0x30
	IORWF R0L,W
	MOVWF 0x3C
; 187: ascbfr0 = ascbfr0 Or 0x30
	MOVF 0x3D,W
	MOVWF R0L
	MOVLW 0x30
	IORWF R0L,W
	MOVWF 0x3D
; 188: Return
	RETURN
; 189: 
; End of program
L0012:	GOTO L0012
; Multiplication Routine
M001:	MOVLW 0x10
	MOVWF R4L
	CLRF R0H
	CLRF R0L
M002:	RRF R3H,F
	RRF R3L,F
	BTFSS STATUS,C
	GOTO M003
	MOVF R1L,W
	ADDWF R0L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R0H,F
M003:	RRF R0H,F
	RRF R0L,F
	RRF R2H,F
	RRF R2L,F
	DECFSZ R4L,F
	GOTO M002
	MOVF R2L,W
	RETURN
; Division Routine
D001:	MOVLW 0x10
	MOVWF R3L
	CLRF R2H
	CLRF R2L
D002:	RLF R0H,W
	RLF R2L,F
	RLF R2H,F
	MOVF R1L,W
	SUBWF R2L,F
	MOVF R1H,W
	BTFSS STATUS,C
	INCFSZ R1H,W
	SUBWF R2H,F
	BTFSC STATUS,C
	GOTO D003
	MOVF R1L,W
	ADDWF R2L,F
	MOVF R1H,W
	BTFSC STATUS,C
	INCFSZ R1H,W
	ADDWF R2H,F
	BCF STATUS,C
D003:	RLF R0L,F
	RLF R0H,F
	DECFSZ R3L,F
	GOTO D002
	MOVF R0L,W
	RETURN
; Comparison Routine
C001:	MOVWF R1L
	MOVLW 0x05
	GOTO C007
C002:	MOVWF R1L
	MOVLW 0x02
	GOTO C007
C003:	MOVWF R1L
	MOVLW 0x06
	GOTO C007
C004:	MOVWF R1L
	MOVLW 0x03
	GOTO C007
C005:	MOVWF R1L
	MOVLW 0x04
	GOTO C007
C006:	MOVWF R1L
	MOVLW 0x01
	GOTO C007
C007:	MOVWF R4L
	MOVF R1H,W
	SUBWF R0H,W
	BTFSS STATUS,Z
	GOTO C008
	MOVF R1L,W
	SUBWF R0L,W
C008:	MOVLW 0x04
	BTFSC STATUS,C
	MOVLW 0x01
	BTFSC STATUS,Z
	MOVLW 0x02
	ANDWF R4L,W
	BTFSS STATUS,Z
	MOVLW 0xFF
	RETURN
; Waitms Routine
W001:	MOVF R0L,F
	BTFSC STATUS,Z
	GOTO W002
	CALL W003
	DECF R0L,F
	NOP
	NOP
	NOP
	NOP
	NOP
	GOTO W001
W002:	MOVF R0H,F
	BTFSC STATUS,Z
	RETURN
	CALL W003
	DECF R0H,F
	DECF R0L,F
	GOTO W001
W003:	MOVLW 0x0C
	MOVWF R2H
W004:	DECFSZ R2H,F
	GOTO W004
	NOP
	NOP
	MOVLW 0x4E
	MOVWF R1L
W005:	DECFSZ R1L,F
	GOTO W006
	CALL W007
	CALL W007
	NOP
	NOP
	RETURN
W006:	CALL W007
	GOTO W005
W007:	MOVLW 0x0D
	MOVWF R2L
W008:	DECFSZ R2L,F
	GOTO W008
	NOP
	RETURN
; Waitus Routine - Byte Argument
X001:	MOVLW 0x03
	SUBWF R4L,F
	BTFSS STATUS,C
	RETURN
	GOTO X002
X002:	MOVLW 0x02
	SUBWF R4L,F
	NOP
	NOP
	BTFSS STATUS,C
	RETURN
	GOTO X002
; Waitus Routine - Word Argument
Y001:	MOVLW 0x04
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	BTFSS STATUS,C
	RETURN
	GOTO Y002
Y002:	MOVLW 0x03
	SUBWF R4L,F
	CLRW
	BTFSS STATUS,C
	ADDLW 0x01
	SUBWF R4H,F
	NOP
	NOP
	BTFSS STATUS,C
	RETURN
	GOTO Y002
; Adcin Routine
A001:	RLF R0L,F
	RLF R0L,F
	RLF R0L,F
	MOVLW 0x38
	ANDWF R0L,F
	MOVLW 0xC1
	IORWF R0L,W
	MOVWF ADCON0
	MOVLW 0x0A
	MOVWF R4L
	CALL X001
	BSF ADCON0,GO
A002:	BTFSC ADCON0,GO
	GOTO A002
	BCF PIR1,ADIF
	BCF ADCON0,ADON
	RETURN
; Lcdout Routine
LC01:	BSF 0x07,0
	MOVWF 0x08
	CALL LCX1
	MOVLW 0x64
	MOVWF R4L
	CALL X001
	RETURN
LCX1:	BSF 0x07,1
	NOP
	NOP
	NOP
	NOP
	BCF 0x07,1
	NOP
	NOP
	NOP
	NOP
	RETURN
; Lcdcmdout Routine
LC02:	BCF 0x07,0
	MOVWF 0x08
	CALL LCX1
	MOVLW 0x64
	MOVWF R4L
	MOVLW 0x00
	MOVWF R4H
	CALL Y001
	RETURN
; End of listing
	END
