'Updated parameters  15Feb2010
'16F877A PIC with a 16mHz Xtal


'0.5v = 0l = 0%
'3.71v = 20l = 100%

'NOTE: The resistive divider on the 5V input is set to give 4.88v, which is 1000 adc counts
'that means we must also correct the 0.5v and 3.71v by the same factor
'So 4.888/5.000 = 0.976
'5.0V external *  0.976 = 4.88  at the adc input == 1000 adc counts
'0.5V external  * 0.976 = 0.48V at the adc input ==  100 adc counts  = 0%  0L
'3.71v external * 0.976 = 3.62v at the adc input ==  741 counts      = 100% 20L
'2.1v is the centre point so, 2.05v at the adc input = 420 counts    = 50%  10L

''Define SIMULATION_WAITMS_VALUE = 1  'make this =0 for programming a PIC

Define ADC_CLOCK = 3  'default value is 3
Define ADC_SAMPLEUS = 10  'default value is 20
Define LCD_BITS = 8  'allowed values are 4 and 8 - the number of data interface lines
Define LCD_DREG = PORTD
Define LCD_DBIT = 0  '0 or 4 for 4-bit interface, ignored for 8-bit interface
Define LCD_RSREG = PORTC
Define LCD_RSBIT = 0
Define LCD_EREG = PORTC
Define LCD_EBIT = 1
Define LCD_RWREG = 0
Define LCD_RWBIT = 0  'set to 0 if not used, 0 is default
Define LCD_COMMANDUS = 100  'delay after LCDCMDOUT, default value is 5000
'Define LCD_DATAUS = 10 'delay after LCDOUT, default value is 50
'Define LCD_INITMS = 1 'delay used by LCDINIT, default value is 100
'the last three Define directives set the values suitable for simulation; they should be omitted for a real device
'------------------------------------
'setup temp variables
Dim ascbfr4 As Byte
Dim ascbfr3 As Byte
Dim ascbfr2 As Byte
Dim ascbfr1 As Byte
Dim ascbfr0 As Byte

Dim temp3 As Word
Dim binval As Word

Dim volt0 As Word
Dim vol1 As Word

Dim intrcnt As Byte
Dim adcavg1 As Word

'''''''''''''''''''
T1CON.T1OSCEN = 1
T1CON.TMR1CS = 0
T1CON.TMR1ON = 1
T1CON.T1CKPS0 = 1  'tmr1 prescaler /256 gives a 2 microsec clock period
T1CON.T1CKPS1 = 1

TMR1H = 0x3c  ''0x3c ~ 0.1 sec/intr
TMR1L = 0xb0  ''0xb0

INTCON.GIE = 1
INTCON.PEIE = 1

PIR1.TMR1IF = 0
'''''''''''''''''''''''''''''''

ADCON0 = %01000001  'fosc/8
ADCON1 = %10000100  'Dis clk div,,,an0 > an3 analaog rest dig

TRISA = %00001111
TRISB = %00000001  'reserve portb.0 for ext interrupts, if required
TRISC = %11111111
'-----------------------------------------------------

Lcdinit

Lcddefchar 0, 31, 31, 31, 31, 31, 31, 31, 31
Lcddefchar 1, %00011111, %00011111, %00011111, %00011111, %00011111, %00011111, %00011111, %00011111
Lcdout 0, 1, 1, 0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1
Lcdcmdout LcdLine2Home
Lcdout 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

WaitMs 1000

Lcdcmdout LcdHome
Lcdout "**Initialising**"
Lcdcmdout LcdLine2Home
Lcdout "*****FLIPS******"
WaitMs 750
Lcdcmdout LcdHome
Lcdout " PLEASE "
Lcdcmdout LcdLine2Home
Lcdout " WAIT "
WaitMs 750
Lcdcmdout LcdClear

main0:

PIR1.TMR1IF = 0
PIE1.TMR1IE = 1  'enable TMR1 interrupt
adcavg1 = 0
vol1 = 0
Enable  'enable interrupts

main:  'loop

If intrcnt > 4 Then
intrcnt = 0

vol1 = adcavg1 / 5  'get the average
adcavg1 = 0

'test for lower and upper limits
If vol1 < 100 Then  'less than 0.488v [0.5v]
vol1 = 0
Goto show1
Endif

If vol1 > 741 Then  'greater/equal 3.62v [3.71v]
vol1 = 1000
Goto show1
Endif

vol1 = vol1 * 81  'adjust the span of the range
vol1 = vol1 - 8100  'subtract the offset adjusted
vol1 = vol1 / 52

show1:
binval = vol1
Gosub bin2asc
Lcdcmdout LcdLine1Home
Lcdout "Percent: ", ascbfr3, ascbfr2, ascbfr1, ".", ascbfr0, "%"

binval = vol1 / 5
Gosub bin2asc
Lcdcmdout LcdLine2Home
Lcdout "Volume:", ascbfr2, ascbfr1, ".", ascbfr0, "L"

Endif

Goto main

End                                               
On Interrupt
Save System

PIR1.TMR1IF = 0

TMR1H = 0x3c  ''0x3c
TMR1L = 0xb0  ''0xb0

intrcnt = intrcnt + 1

'scale the 5V input to 4.88v using a resistive divider
readadc:  'read adc word
Adcin 0, volt0

adcavg1 = adcavg1 + volt0

Resume                                            


'you can convert any binary value from 0000h to fffFh to 0000 to 65535 decimal
'just name the binary word as binval and call this subr and the ASCII
'result will be in ascbfr4,3,2,1,0, ready for your LCD or UART
'just pop the DP in the output to the LCD [as shown above]

bin2asc:
'ascbfr4 = binval / 10000 'add these 4 lines for 16 bit conv
'temp3 = binval Mod 10000
'ascbfr3 = temp3 / 1000
'temp3 = binval Mod 1000

ascbfr3 = binval / 1000  'delete for 16 bit conv
temp3 = binval Mod 1000  'delete for 16 bit

ascbfr2 = temp3 / 100
temp3 = temp3 Mod 100

ascbfr1 = temp3 / 10
ascbfr0 = temp3 Mod 10
'results are BCD so
'convert to ASCII for LCD or UART
ascbfr4 = ascbfr4 Or 0x30
ascbfr3 = ascbfr3 Or 0x30
ascbfr2 = ascbfr2 Or 0x30
ascbfr1 = ascbfr1 Or 0x30
ascbfr0 = ascbfr0 Or 0x30
Return                                            

